#!/usr/bin/perl
# Anzeige der Terminalinformation aus Turbo-Pascal 2.x 3.x
# V. Pohlers, 26.09.2011

# use Data::Dumper;
                  
#                    ;Screen-Installationsbereich
#                    ;----------------------------
#                    
#                    ;Terminal >>
#  0153  TermTypStr:	DEFB	20,'No Terminal selected'
#  0168  Width:		DEFB	80		;Bildschirmbreite (1-256)
#  0169  Height:	DEFB	24		;Bildschirmhoehe  (1-256)
#  016A  		DEFB	0		;wozu das?
#        
#        ;Ab hier werden die Installationsdaten von der Laufzeitbibliothek verwendet
#  016B  InitialStr:	DEFS	16
#  017B  ResetStr:	DEFS	16
#        
#        ;Cursor >>
#  018B  CursorStr:	DEFS	16		;Muster fuer Cursor-Positionierung
#  019B  BinaryAddr:	DEFB	0		;0=ASCII, 1=Binary address
#  019C  ColumnOff:	DEFB	0
#  019D  LineOff:	DEFB	0
#  019E  XPosition:	DEFB	0		;Pos. in Muster
#  019F  YPosition:	DEFB	0		;	"
#  01A0  DelayCursor:	DEFW	0		;Delay after cursor address (0-255 ms)
#        
#        ;Line >>
#  01A2  ClearScrStr:	DEFS	6		;Clear screen
#  01A8  HomeStr:	DEFS	6		;Home cursor (Dieser String ist leer,
#        					;wenn Clear screen schon Home macht)
#  01AE  InsLineStr:	DEFS	6		;Insert line
#  01B4  DelLineStr:	DEFS	6		;Delete line
#  01BA  DelayLine:	DEFW	0		;Delay after Clear, Delete and Insert (0-255 ms)
#        
#        ;Highlight >>
#  01BC  EraToEolStr:	DEFS	6		;Erase to end of line
#  01C2  HLStartStr:	DEFS	6		;Start highlighting
#  01C8  HLEndStr:	DEFS	6		;End highlighting
#  01CE  DelayHL:	DEFW	0		;Delay after EraToEol and HighLight
#                    
#  01D0  

$IN = $ARGV[0] || "turbo.com";
open IN;
binmode IN;
seek IN, 0x053, 0;

read IN, $terminal, 0x0D0-0x053; 
close IN;

print length($terminal), "\n";

@erg = ();
@erg = unpack("
	C		# Stringlength
	a20		# TermTypStr
	C		# Width
	C		# Height
	C		# ???
	a16		# InitialStr
	a16		# ResetStr
	a16		# CursorStr
	C		# BinaryAddr
	C		# ColumnOff
	C		# LineOff
	C		# XPosition
	C		# YPosition
	S		# DelayCursor
	a6		# ClearScrStr
	a6		# HomeStr
	a6		# InsLineStr
	a6		# DelLineStr
	S		# DelayLine
	a6		# EraToEolStr
	a6		# HLStartStr
	a6		# HLEndStr
	S		# DelayHL
	", $terminal
);

# print Data::Dumper->Dump([\@erg], ["*erg"]);

printf "0153  TermTypStr:  %d,%s\n", $erg[0], substr($erg[1],0,$erg[0]);
printf "0168  Width:       %d\n", $erg[2];
printf "0169  Height:      %d\n", $erg[3];
printf "016A  ???:         %d\n", $erg[4];
printf "016B  InitialStr:  %s\n", tostr($erg[5]);
printf "017B  ResetStr:    %s\n", tostr($erg[6]);
printf "018B  CursorStr:   %s\n", tostr($erg[7]);
printf "019B  BinaryAddr:  %d\n", $erg[8];
printf "019C  ColumnOff:   %d\n", $erg[9];
printf "019D  LineOff:     %d\n", $erg[10];
printf "019E  XPosition:   %d\n", $erg[11];
printf "019F  YPosition:   %d\n", $erg[12];
printf "01A0  DelayCursor: %d\n", $erg[13];
printf "01A2  ClearScrStr: %s\n", tostr($erg[14]);
printf "01A8  HomeStr:     %s\n", tostr($erg[15]);
printf "01AE  InsLineStr:  %s\n", tostr($erg[16]);
printf "01B4  DelLineStr:  %s\n", tostr($erg[17]);
printf "01BA  DelayLine:   %d\n", $erg[18];
printf "01BC  EraToEolStr: %s\n", tostr($erg[19]);
printf "01C2  HLStartStr:  %s\n", tostr($erg[20]);
printf "01C8  HLEndStr:    %s\n", tostr($erg[21]);
printf "01CE  DelayHL:     %d\n", $erg[22];


sub hex2 {
	return sprintf("%02X",shift);
}	

sub tostr() {
	my $in = shift;
	my $out = '';
	my $len = ord(substr($in,0,1));
	for ($i=0; $i<=$len; $i++) {
		$c = substr($in,$i,1);
		
		if ($c ge ' ' && $c lt chr(0x7f) ) {
			$out .= "'$c',";
		} else {
			$out .= hex2(ord($c)) . ',';
		}
	}
	$out =~ s/,$//;
	$out;
}
